<?php
/**
 * Imports MediaWiki pages in HTML format to tikiwiki.
 *
 * Must be run after mw2html.pl script
 *
 * Must be placed in ${tiki_base_dir}/import directory
 */
error_reporting( E_ALL );

if( phpversion() < '5.0.0' )
	die( 'PHP 5 Required. Version ' . phpversion() . " detected\n" );


class ImportMediaWikiPages
{
	function import()
	{
	    global $namespaces;
	    global $table_prefix;
	    
	    $pages=array();	    
	    $keys = array_keys($namespaces);

	    foreach ($keys as $ns_id){

		$query = "SELECT page_id,page_title FROM $table_prefix"."page WHERE page_namespace=$ns_id";
		$result = mysql_query($query) or die("Query failed : " . mysql_error());
	
		while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
		
		    array_push($pages, array("id" => $line['page_id'], "title" => $line['page_title'], "ns" => $ns_id));
		}
	    
		mysql_free_result($result);
	    }

	    	
	    foreach($pages as $page){
	    
		$pdata = $this->extractInfo( $page['id'] );
		$pdata['title'] = $page['title'];
		$pdata['title'] = $namespaces["{$page['ns']}"]['join_titles'] ? $namespaces["{$page['ns']}"]['name'].':'.$page['title'] : $page['title'];
#		$pdata['title'] = preg_replace("/\:_/", ":", $pdata['title']);
#		$pdata['title'] = preg_replace("/\:/", "_", $pdata['title']);
		$pdata['id'] = $page['id'];

    print "Page: {$pdata['title']}\n";
    flush();

	    $this->importPage( $pdata );
	    }
	

	}

	function extractInfo( $p_id )
	{
	
		global $table_prefix;
	
		$rinfo = array();
		$rinfo['revisions'] = array();
		$rtemp=array();
		$query="SELECT page_latest FROM $table_prefix"."page WHERE page_id=$p_id";
//		$query="SELECT rev_id FROM revision WHERE rev_page=$p_id";
		$result = mysql_query($query) or die("Query failed : " . mysql_error());

		while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {

//		    array_push($rtemp, $line['rev_id'] );
		    array_push($rtemp, $line['page_latest'] );
		}
		mysql_free_result($result);
		
		foreach ($rtemp as $rev){
		
		    array_push($rinfo['revisions'], $this->extractRevision( $rev ));
		
		}
		
		return $rinfo;
	}


	function extractRevision( $rev )
	{

	    global $table_prefix;
	    
	    $rdata = array();
	    
	    $query = "SELECT rev_text_id, rev_user, rev_user_text, rev_timestamp, rev_minor_edit FROM $table_prefix"."revision WHERE rev_id=$rev";
	    $result = mysql_query($query) or die("Query failed : " . mysql_error());


	    while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
		    
		$txt_id = $line['rev_text_id'];
		$rdata['contributor']= array("id" => $line['rev_user'], "username" => $line['rev_user_text'], "ip" => "0.0.0.0");

    		if ( $line['rev_minor_edit'] == 1 ) {
    		    $rdata['minor'] = true;
    		}else{
    		    $rdata['minor'] = false;
    		}
    		
    		$rdata['id'] = $rev;
    		$rdata['timestamp'] = strtotime($line['rev_timestamp']);
    		
	    }

	    mysql_free_result($result);
	    
	    $query = "SELECT old_text FROM $table_prefix"."html WHERE old_id = $txt_id";
	    $result = mysql_query($query) or die("Query failed : " . mysql_error());


	    while ($line = mysql_fetch_array($result, MYSQL_ASSOC)) {
	    
		$rdata['text'] = $line['old_text'];
	    
	    }
	    mysql_free_result($result);

	    return $rdata;
	}
	


	function importPage( $data )
	{
		global $tikilib;


		if( $tikilib->page_exists( $data['title'] ) )
		{
			print "Page already exists, no action taken: {$data['title']}\n";
			return;
		}

		$first = true;
		foreach( $data['revisions'] as $rev )
		{
			if( $first )
			{
				// Invalidate cache
				$tikilib->create_page(
					$data['title'],
					0,
					$rev['text'],
					$rev['timestamp'],
					$rev['comment'],
					$rev['contributor']['username'],
					$rev['contributor']['ip'],
					'',
					'',
					true
				);
			}
			else
			{
				$tikilib->cache_page_info = null;
				$tikilib->update_page(
					$data['title'],
					$rev['text'],
					$rev['comment'],
					$rev['contributor']['username'],
					$rev['contributor']['ip'],
					'',
					$rev['minor'],
					'',
					true,
					null,
					$rev['timestamp']
				);
			}

			$first = false;
		}
	}
}

?>