<?php
// twiki2tiki.php v.0.4 2005/11/23
// Conversion script for importing a TWiki web into TikiWiki
// Copyright (C) 2005 Arthur Davis
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE.
// See license.txt for details.
// Modified by Dmitry Ganin
?>
<HTML>
<HEAD>
<STYLE type="text/css">
BODY { background-color: #e1d3b9;
 color: black; font: medium Arial, sanserif;
 font-size:10pt; }
H1 { background-color: #cccccc;
font-weight:bold; font-size:1.2em;
width: 20em; text-align: center;}
H2 { font-weight:bold; font-size:1.1em; margin: 0;}
.BOX {border-style: ridge; border-color: #333333;
font: medium Courier, monospace;
font-size: 1.0em;
width: 50em;
border-width: medium; padding: 0.5em;
background-color: #ffffff;
margin-top: 0.5em; margin-bottom: 0.5em; }
</STYLE>
<TITLE>Translate TWiki pages into Tiki pages</TITLE>
</HEAD>
<BODY>
<H1>Twiki2Tiki conversion script</H1>
<H2>Database info:</H2>
<?php
// Show all errors for debugging
error_reporting(E_ALL);
include("twiki2tiki_cfg.php");
ini_set('include_path',".:".TIKI_DIR);
include("lib/mime/mimelib.php"); // Borrow the tiki mime id function
define('EOL',"<br/></DIV>\n");
echo("DB_HOST: ".DB_HOST."</br>\n");
echo("DB_NAME: ".DB_NAME."</br>\n");
echo("DB_USER: ".DB_USER."</br>\n");
echo("DB_PASS: ".md5(DB_PASS)."</br>\n");
echo("<DIV CLASS=BOX>Checking for connection to database... ");
$tikidb=mysql_connect(DB_HOST,DB_USER,DB_PASS)
or die("<br/>Connection failed: ".mysql_error().EOL);
mysql_select_db(DB_NAME,$tikidb)
or die("<br/>Table missing: ".mysql_error().EOL);
echo("confirmed".EOL);
echo("<H2>Files and directories:</H2>\n");
echo("TIKI_FILEDEST: ".TIKI_FILEDEST."</br>\n");
echo("TIKI_DIR: ".TIKI_DIR."</br>\n");
echo("TWIKI_DIR: ".TWIKI_DIR."</br>\n");
echo("TWIKI_WEB: ".TWIKI_WEB."</br>\n");
$twikidatadir=TWIKI_DIR."/data/".TWIKI_WEB;
$twikiattachdir=TWIKI_DIR."/pub/".TWIKI_WEB;
echo("TWiki Data Directory: $twikidatadir</br>\n");
echo("TWiki Attachments Dir: $twikiattachdir</br>\n");
echo("<DIV CLASS=BOX>Checking for file access... ");
is_readable(TWIKI_DIR)
or die("<br/>Cannot access ".TWIKI_DIR.EOL);
is_readable($twikidatadir)
or die("<br/>Cannot access $twikidatadir ".EOL);
is_readable($twikiattachdir)
or die("<br/>Cannot access $twikiattachdir ".EOL);
is_writable(TIKI_FILEDEST)
or die("<br/>Cannot write to ".TIKI_FILEDEST.EOL);
echo("confirmed".EOL);
// Get a list of the wiki pages to translate
$fh=opendir($twikidatadir);
while(false!==($file=readdir($fh))) {
    if(preg_match('/(.*)\.txt$/',$file,$pagename)) {
    // Ignore the ignorables
    if(!in_array($pagename[1],$ignore_pages)) {
	 $filepages[]=$pagename[1];
     }
    // echo("$pagename[1]<br/>\n");
    }
}
closedir($fh);
echo("<H2>Import Pages:</H2><DIV CLASS=BOX>\n");
foreach($filepages as $page) {
    echo("$page... <br/>\n");
    //$contents=file_get_contents("$twikidatadir/$page.txt")
    $contents=file("$twikidatadir/$page.txt")
    or die("Cannot read file $page.txt".EOL);
    $attpage=$page; // The location of attachment files
    // Change the name of the WebHome page as configured
    $page=($page=="WebHome")?TWIKI_WEB:$page;

    // Check for page name duplication
    $is_duplicated_pages=FALSE;
    
    $query_result=mysql_query("SELECT * FROM tiki_pages WHERE pageName='$page'",$tikidb)
	or die("SQL error: ".mysql_error().EOL);
    if(mysql_num_rows($query_result)) {
	$is_duplicated_pages=TRUE;
	 echo("<strong>Duplicated pages detected!!! Page:$page </strong><br/>\n");
    }

    $is_table=FALSE;
    $output='';
    foreach ($contents as $content_index=>$linedata) {
	// Get the TOPICINFO metadata
	$pattern='/%META:TOPICINFO.*author=\"(.*?)\".*date=\"(.*?)\"/';
	if(preg_match($pattern,$linedata,$match)) {
	    $pageuser=$match[1];
	    $pagedate=$match[2]; 
	    continue;
	}

	// Get the TOPICPARENT metadata
        // TODO: write some code to actually use it
	$pattern='/%META:TOPICPARENT.*name=\"(.*?)\"/';
        if(preg_match($pattern,$linedata,$match)) {
        //	$topic_parent=$match[1];
		continue; 
        }

	// Rule to convert headings
        if(preg_match('/---\++/',$linedata,$match)) {
	    $headstring=str_replace("-","",$match[0]);
	    $headstring=str_replace("+","!",$headstring);
	    // Use the following line to promote Tiki headings to "one bigger"
	    // then how they're defined in the TWiki Web. Otherwise,
	    // comment out
	    $headstring=substr($headstring,0,-1);
	    $linedata=preg_replace('/---\++/',$headstring,$linedata);
	}

	// Rule to convert bullet lists
	if(preg_match('/^\s+\*/',$linedata,$match)) {
	    $bullstring=str_replace("*","",$match[0]);
	    $bullstring=preg_replace('/\s/',"*",$bullstring);
	    $linedata=preg_replace('/^\s+\*/',$bullstring,$linedata);
	}

        // Rule to convert enumerated lists
	if(preg_match('/^\s+1\./',$linedata,$match)) {
	    $bullstring=str_replace("1.","",$match[0]);
	    $bullstring=preg_replace('/\s/',"#",$bullstring);
	    $linedata=preg_replace('/^\s+1\./',$bullstring,$linedata);
	}

	$pattern=array(
        // Make some logical replacements of TWiki Variables
    	    '/%HOMETOPIC%/',
	    '/%WEB%/',
	    '/%TOC%/',
	// Rule to convert italic type
	    '/(\s|^)_([$a-zA-Z0-9\s.\/!:,]+?)_(\s|:|\.|$)/',
	// Rule to convert bold italic type
    	    '/(__.+?__)/',
        // Rule to convert bold type (should appear after bullet list rule)
    	    '/(\s|^|\|){0,1}\*([$\[\]()a-zA-Z0-9._]+?\s*?.*?)\*(\s|:|\.|$|\|)/',
        // Rules to convert preformatted text
	    '/(\s|^|\()=([a-zA-Z0-9\s.\-<>\/*;=]+?)=(\s|:|\.|$|\))/',
	    '/<verbatim>/','/<\/verbatim>/',
	// Convert any <code> references
	    '/<code>/i','/<\/code>/i',
	// just scrap <br/> and %br% tags (match case-insensitive)
    	    '/<br(\s*?)\/{0,1}>/i',
	    '/%br%/i',
	// throw out %COMMENT% tags
	    '/%COMMENT.*?%/',
        // Remap icons to smileys
	    '/%Y%/','/%N%/','/%P%/','/%S%/',
        // Rewrite attached file syntax
	    '/\[\[%ATTACHURL%\/(.*?)\]\[(.*?)\]\]/',
        // Rewrite attached image syntax
	    '/<img src="%ATTACHURLPATH%\/(.*?)"\salt="(.*?)"\s.*?>/',
	    '/<img src="%ATTACHURLPATH%\/(.*?)".*?>/',
	// Translate Formulas
	    '/%\$(.*?)\$%/',
	    '/%\\\\\[(.*?)\\\\\]%/',
	// Convert <nop>WhateverWord into ))WhateverWord((
	    '/<nop>(\w+)/i',
	// Translate <a hrefs>. Embedded div's will cause a problem
    	    '/<a\s+?href=["\']{0,1}([\/\w]{1}.*?)["\']{0,1}>(.*?)<\/*?a>/i',
	// Translate %COLOR% tags to Tiki syntax
	    '/%YELLOW%/','/%ORANGE%/','/%RED%/','/%PINK%/','/%PURPLE%/','/%TEAL%/',
	    '/%NAVY%/','/%BLUE%/','/%AQUA%/','/%LIME%/','/%GREEN%/','/%OLIVE%/',
	    '/%MAROON%/','/%BROWN%/','/%BLACK%/','/%GRAY%/','/%SILVER%/','/%WHITE%/',
    	    '/%ENDCOLOR%/',
	);
	$replace=array(
	// Make some logical replacements of TWiki Variables
	    TIKI_HOMEPAGE,
	    TWIKI_WEB,
	    "",
	// Rule to convert italic type
	    "\\1''\\2''\\3",
        // Rule to convert bold italic type
    	    "''\\1''",
	// Rule to convert bold type (should appear after bullet list rule)
	    "\\1__\\2__\\3",
	// Rules to convert preformatted text
    	    "\\1{MONO(font=>)}\\2{MONO}\\3",
	    "~pp~","~/pp~",
	// Convert any <code> references
	    "{CODE()}","{CODE}",
	// just scrap <br/> and %br% tags
	    "","",
	// throw out %COMMENT% tags
	    "",
	// Remap icons to smileys
	    "(:arrow:)","(:exclaim:)","(:question:)","(:idea:)",
	// Rewrite attached file syntax
	    "{file name=\\1 desc=\"\\2\" showdesc=1}",
	// Rewrite attached image syntax
	    "{file name=\\1 image=1 desc=\"\\2\" showdesc=0}",
	    "{file name=\\1 image=1 showdesc=0}",
	// Translate Formulas
	    "{FORMULA()}\\1{FORMULA}",
	    "\n::{FORMULA()}\\1{FORMULA}::\n",
	// Convert <nop>WhateverWord into ))WhateverWord((
	    "))\\1((",
	// Translate <a hrefs>
    	    "[\\1|\\2]",
	// Translate %COLOR% tags to Tiki syntax
	    "~~#ffff00:","~~#ff6600:","~~#ff0000:","~~#ff00ff:","~~#800080:","~~#008080:",
	    "~~#000080:","~~#0000ff:","~~#00ffff:","~~#00ff00:","~~#008000:","~~#808000:",
	    "~~#800000:","~~#996633:","~~#000000:","~~#808080:","~~#c0c0c0:","~~#ffffff:",
	    "~~",
        );

	$linedata=preg_replace($pattern,$replace,$linedata);

	// Rules to convert tables
	if(preg_match('/^\|/',$linedata,$match)) {
	
	    if(!$is_table){ 
	
		$linedata="||".$linedata; 
	    }
	    $is_table=TRUE;
	    // Get rid of leading pipe
    	    $linedata=preg_replace('/^\|/',"",$linedata);
	    // Get rid of trailing pipe
 	    $linedata=preg_replace('/\|+\s*$/',"\n",$linedata);
	    // No vertical span possible as far as I know
 	    $linedata=preg_replace('/\^/',"",$linedata);
	}elseif($is_table){ 

    	    $linedata="||\n".$linedata; $is_table=FALSE; 

	}else{ 

	    $is_table=FALSE;     
	} 

	// Rule to convert external links (should appear before rule to
	// convert Wiki references.
	$pattern2='/\[\[(http.*?)\]\]/';
	if(preg_match($pattern2,$linedata)) {
	    $linedata=preg_replace($pattern2,"[\\1]",$linedata);
	    $linedata=preg_replace('/(\[http.*?)\]\[(.*?\])/',"\\1|\\2",$linedata);
	}

	// Rule to convert Wiki references (must appear after external link rule)
	$pattern2='/\[\[(.*?)\]\]/';
	if(preg_match($pattern2,$linedata)) {
	    $linedata=preg_replace($pattern2,"((\\1))",$linedata);
	    $linedata=preg_replace('/(\(.*?)\]\[(.*?\))/',"\\1|\\2",$linedata);
	}

	// Rule to convert web specific links into simple Wiki references
	if(preg_match('/(?<!@|\.)'.TWIKI_WEB.'\.\w+/',$linedata)) {
	    $linedata=preg_replace('/'.TWIKI_WEB.'\.(\w+)/',"((\\1))",$linedata);
	}

	// Rule to force wikiwords followed by colons or double underscores into wikilinks
	if(preg_match('/([A-Z][a-z]+[A-Z]\w+?)(:|__)/',$linedata,$matches)) {
	    $linedata=preg_replace("/$matches[1]/","(($matches[1]))",$linedata);
	}


	// Collect info on the attached files
	if(preg_match('/%META:FILEATTACHMENT(.*)%/',$linedata,$matches)) {
	    $fileat=$matches[1];
	    preg_match('/name="(.*?)"/i',$fileat,$matches);
	    $filename=$matches[1];
	    $attfilepath="$twikiattachdir/$attpage/$filename";
	    preg_match('/comment="(.*?)"/i',$fileat,$matches);
	    $filedesc=$matches[1];
	    // Eliminate BumpyWords in $filedesc since it cause problems in the img alt field
	    $filedesc=preg_replace('/([A-Z][a-z]+[A-Z]\w+?)/e',"strtolower('\\1')",$filedesc);
	    preg_match('/date="(.*?)"/i',$fileat,$matches);
	    $filedate=$matches[1];
	    preg_match('/size="(.*?)"/i',$fileat,$matches);
	    $filesize=$matches[1];
	    preg_match('/user="(.*?)"/i',$fileat,$matches);
	    $fileuser=$matches[1];
	    // Wipe the line from the buffer
	    $linedata='';
	    //
	    // Get the mime file type
	    $filetype=tiki_get_mime($attfilepath);
	    //var_dump($filetype);echo("<br/>\n");
	    //
	    // Copy the attachment to the tiki directory
	    // $filehash=md5(uniqid(md5($filename))); // generates unique name everytime script is run leading to numerous stale files if import is run more then once
	    $filehash=md5($page.$filename); // generates the same name everytime script is run but unique names per wikipage even if a file in another page has the same name.
	    //echo("copy $attfilepath ".TIKI_FILEDEST."/$filehash<br/>\n");
	
	    if(copy($attfilepath,TIKI_FILEDEST."/$filehash")){
		echo("&nbsp;&nbsp;Copying: $filename, $filesize, $filedate, $filetype <br/>\n");
	    }else{
	        echo("<strong>Failed to copy $filename</strong><br/>\n");
	    }
	    //
	    // Get the last file attachment Id
	    $query_result=mysql_query("SELECT * FROM tiki_wiki_attachments ORDER BY attId DESC LIMIT 1", $tikidb)
    	     or die("SQL error: ".mysql_error($tikidb).EOL);
	    $db_row=mysql_fetch_assoc($query_result);
	    $last_id=$db_row["attId"];
	    //echo("Last File Id: $last_id<br>\n");
	    //
	    // Write the database record
	    $query_result=mysql_query("SELECT * FROM tiki_wiki_attachments WHERE path='$filehash'", $tikidb)
	      or die("SQL error: ".mysql_error($tikidb).EOL);
	
	    if(mysql_num_rows($query_result)) {
		$method="UPDATE";
	        $db_row=mysql_fetch_assoc($query_result);
		$attId=$db_row['attId'];
	    }else{ 
		$method="INSERT";
		$attId=++$last_id;
	    }
	    echo("&nbsp;&nbsp;&nbsp;${method}ing file at $attId<br/>\n");
	    //
	    // Attach to correct page considering possible duplication
	    if($is_duplicated_pages) {
	        $atpage=$page.PAGE_SUFFIX;
	    }else{
		$atpage=$page;
	    }

	    // attId=>$attId, page=>$atpage
	    // filename=>$filename, filetype=>$filetype
	    // filesize=>$filesize, user=>$fileuser
	    // path=>$filehash, downloads=>0,
    	    // created=>$filedate, comment=>$filedesc
	    $filename=mysql_real_escape_string($filename);
	    $filedesc=mysql_real_escape_string($filedesc);
	    $fileuser=mysql_real_escape_string($fileuser);
	    $fields=array('page'=>$atpage,
		'filename'=>$filename,
		'filetype'=>$filetype,
		'filesize'=>$filesize,
		'user'=>$fileuser,
		'path'=>$filehash,
		'hits'=>0,
		'created'=>$filedate,
		'comment'=>$filedesc,
		);
	    $where=array('attId'=>$attId);
	    $sql=construct_query($method,'tiki_wiki_attachments',$fields,$where);
	    $query_result=mysql_query($sql,$tikidb)
	        or die("SQL error: ".mysql_error($tikidb).EOL);

	} // End attaching files

	//
	// Toss out the remaining %META% lines
	$linedata=preg_replace('/^%META.*%$/','',$linedata);

	//
	// Send it to the output string
	$output.=$linedata;
	//echo("TIKI_HOMEPAGE: ".constant("TIKI_HOMEPAGE")."\n");
	//$contents=preg_replace('%HOMETOPIC%',TWIKI_HOMEPAGE,$contents);
    } // endforeach ($contents)

    //echo("Author: $pageuser... Date: $pagedate... ");
    //$query_result=mysql_query("SELECT * FROM tiki_pages WHERE pageName='$page'",$tikidb)
    //or die("SQL error: ".mysql_error().EOL);
    //$method=mysql_num_rows($query_result)==0?'INSERT':'UPDATE';
    //if(mysql_num_rows($query_result)) {
	//$method="UPDATE";
	//$sql_record=mysql_fetch_array($query_result,MYSQL_ASSOC);
	//$page_id=$sql_record['page_id'];
	// echo("<strong>page_id: $page_id </strong><br/>\n");
    //} else {
    $method="INSERT";
    $query_result=mysql_query("SELECT * FROM tiki_pages ORDER BY page_id DESC LIMIT 1",$tikidb)
    or die("SQL error: ".mysql_error().EOL);
    $sql_record=mysql_fetch_array($query_result,MYSQL_ASSOC);
    $page_id=$sql_record['page_id']+1;
    // echo("<strong>page_id: $page_id </strong><br/>\n");
    //}
    //Add suffix to pageName to avoid duplicated pages...
    if($is_duplicated_pages) {
	$pageName=$page.PAGE_SUFFIX;
    }else{
	$pageName=$page;
    }


    $fields=array('pageName'=>$pageName,
	'hits'=>0,
	'data'=>mysql_real_escape_string($output),
	'description'=>'',
	'lastModif'=>$pagedate,
	'comment'=>'',
	'version'=>0,
	'user'=>$pageuser,
	'ip'=>'127.0.0.1',
	'creator'=>$pageuser,
	'created'=>$pagedate
    );
    $where=array('page_id'=>$page_id);
    echo("&nbsp;&nbsp;Method: $method... PageId: $page_id... ");

    $sql=construct_query($method,'tiki_pages',$fields,$where);
    //echo("<br/><em>$sql</em><br/>\n");
    $query_result=mysql_query($sql,$tikidb)
	or die("SQL error: ".mysql_error().EOL);

    echo("Done.<br/>\n");
    }
echo("</DIV>\n");
mysql_close($tikidb);
// TODO: include mod_rewrite rules to preserve old TWiki bookmarks
// ******************************************************
// Construct the proper text for making the mysql_query
// Either INSERT of UPDATE are valid values for $type
// $record for the name of the record to act on
// and $fields contains the assoc. array of data to set
function construct_query($type,$record,$fields,$where) {
    $lastelem=end($fields);
    $lastkey=key($fields);
    reset($fields);
    if($type == 'INSERT') {
	$qstring="$type INTO $record (";
	if($where) {
	    while(list($key,$value)=each($where)) {
		$keys[]=$key;
		$values[]=$value;
	    }
	}
	while(list($key,$value)=each($fields)) {
	    $keys[]=$key;
	    $values[]=$value;
	}
	$i=0;
	$vstring='';
	foreach($keys as $keyword) {
	    $qstring.=("$keyword");
	    $qstring.=($keyword==$lastkey?') VALUES (':',');
	    $vstring.=("'$values[$i]'");
	    $vstring.=($keyword==$lastkey?')':',');
	    $i++;
	}
    $qstring.=$vstring;
    }elseif($type=='UPDATE') {
	$qstring="$type $record SET ";
	while(list($key,$value)=each($fields)) {
	    $qstring.=("$key='$value'");
	    $qstring.=($key==$lastkey?'':',');
	}
	if($where) { $qstring.=" WHERE ";
	    $lastwhere=end($where);
	    reset($where);
	    while(list($key,$value)=each($where)) {
		$qstring.=("$key='$value'");
		$qstring.=($value==$lastwhere?'':' AND ');
	    }
	}
	$qstring.=" LIMIT 1";
    }else{
	die("Invalid database method: $type".EOL);
    }
    return($qstring);
} //end function: construct_query
// ******************************************************
echo("</BODY>\n</HTML>\n");
// ------------------------------------------------------
?>
